module StellaratorOptimization
using Requires
using OrderedCollections
using Polyester
using Printf

using PlasmaEquilibriumToolkit

const StellOpt = StellaratorOptimization
export StellOpt

const NO_EQUILIBRIUM = 1.0e10

abstract type AbstractOptTarget end;

abstract type AbstractOptVariable end;
   
abstract type AbstractOptEquilibrium end;

abstract type AbstractModuleWrapper end;

include("equilibrium_wrapper.jl")
include("Variables.jl")
include("Target.jl")
include("Types.jl")
include("macros.jl")
include("utilities.jl")
include("optimize_threads.jl")


function __init__()
    @require MPI="da04e1cc-30fd-572f-bb4f-1f8673147195" begin
        include("optimize_mpi.jl")
    end
end


end
